//+---------------------------------------------------------------------------------------------------------------+
//|                                                                                      Ilan1.6Dynamic_N1.03.mq4 |
//|                                                                                      Copyright  2012, skumen |
//|                                                                                              skumen@gmail.com |
//|                                                                                        http://ruforum.mt5.com |
//+---------------------------------------------------------------------------------------------------------------+

//---------------------------    Ilan1.6Dynamic_m  ir0407(wlmaster@mail.ru) ----------------------------|
//-----------------------------          --------------------------------|


//N1.01     ;
//       lotdecimal  ;
//       Slippage(slip)     ;
//         RSI   RsiLevel;
//       : Rsi_TF -  timeframe   RSI;(09.07.12)
//N1.02      Market Execution(TP=0,  );
//N1.03     (DynamicPips);(23.07.12)


#property copyright "" 
#property link      ""

#include <stderror.mqh>
#include <stdlib.mqh>

extern double Lots            = 0.01; //     
extern double LotExponent     = 1.4;  //        (1...1.8)
extern int    TakeProfit      = 10;   //       
extern int    MaxTrades       = 5;    //     (5...15)
extern bool   DynamicPips     = TRUE;
extern int    DefaultPips     = 12;   //   (12...48)
extern int    Glubina         = 36;   //     (12...48)
extern int    DEL             = 3;    //     (1...3)
extern int    RsiLevel        = 30;   //      RSI(5...45)
extern int    RsiPeriod       = 14;   //   RSI(7...42)
extern int    Rsi_TF          = 0;    // 0 -   , 1 - M5, 2 - M15, 3 - M30, 4 - 1(0...4)
extern bool   UseEquityStop   = FALSE;//   
extern double TotalEquityRisk = 20.0; //    %  
extern bool   Debug           = True; // /    
extern int    MagicNumber     = 2222; 
//---------------------------------------------------------------------------------------------------------------------
int timeprev = 0, PipStep=0, NumOfTrades = 0, cnt = 0, total, ticket, Error, lotdecimal, RsiMin, RsiMax, Slippage, DcD = 1;
bool TradeNow = FALSE, LongTrade = FALSE, ShortTrade = FALSE, NewOrdersPlaced = FALSE, NeedModifyOrder = False, flag;
double PriceTarget, StartEquity, BuyTarget, SellTarget, AccountEquityHighAmt, PrevEquity;
double AveragePrice, SellLimit, BuyLimit, iLots, LastBuyPrice, LastSellPrice, Spread;
string EAName="Ilan1.6Dynamic_N1.03";
int mper[5] = {0,5,15,30,60};
datetime  LastTickTime;
//---------------------------------------------------------------------------------------------------------------------
int init() 
{
  lotdecimal = MathLog(1/MarketInfo(Symbol(),MODE_LOTSTEP))/MathLog(10);
  Spread = MarketInfo(Symbol(), MODE_SPREAD) * Point;
  Slippage = 2*(MarketInfo(Symbol(), MODE_SPREAD));
  RsiMin = RsiLevel;  
  RsiMax = 100 - (RsiLevel);
  
  if((Digits==5)||(Digits==3)) 
       {
       DcD = 10;
       DefaultPips = DefaultPips*DcD;
       TakeProfit = TakeProfit*DcD;
       }
  return (0);
}

int deinit() 
{
  return (0);
}
//---------------------------------------------------------------------------------------------------------------------
int start()
{
  double PrevCl;
  double CurrCl;

  if (timeprev == Time[0]) return(0);   //   

  /*****************************************************************************/
  /*    ,        */ 
  /*****************************************************************************/
  timeprev = Time[0];

  //===================================================================================================================
  //    . 
  //===================================================================================================================
  if (DynamicPips)  
   {
     double hival=High[iHighest(NULL,0,MODE_HIGH,Glubina,1)];                            
     double loval=Low[iLowest(NULL,0,MODE_LOW,Glubina,1)];                               
     PipStep=NormalizeDouble((hival-loval)/DEL/Point,0);                                 
     if (PipStep<DefaultPips/DEL) PipStep = NormalizeDouble(DefaultPips/DEL,0);
     if (PipStep>DefaultPips*DEL) PipStep = NormalizeDouble(DefaultPips*DEL,0);          
   } 
   else PipStep = DefaultPips;        
  //===================================================================================================================
  //     . 
  //===================================================================================================================
  double CurrentPairProfit = CalculateProfit();   //  /  
  if (UseEquityStop)
    if (CurrentPairProfit < 0.0 && MathAbs(CurrentPairProfit) > TotalEquityRisk / 100.0 * AccountEquityHigh()) 
    {
      CloseThisSymbolAll();
      Print("Closed All due to Stop Out");
      NewOrdersPlaced = FALSE;
    }
   
  //===================================================================================================================
  //   ,    .
  //===================================================================================================================
  total = CountOfOrders();    
  if (total > 0)  //        ,   .
  {
    for (int i = 0; i < OrdersTotal(); i++) 
      if(OrderSelect( i, SELECT_BY_POS, MODE_TRADES))
        if (OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber)
        {
          switch(OrderType())
          {
            case OP_BUY:
              LongTrade = TRUE;
              ShortTrade = FALSE;
              break;
            case OP_SELL:
              LongTrade = FALSE;
              ShortTrade = TRUE;
              break;//   switch
          }
          break;//   for
        }
  //===================================================================================================================
  //         
  //===================================================================================================================
    LastBuyPrice = FindLastBuyPrice();
    LastSellPrice = FindLastSellPrice();
    if (LongTrade && LastBuyPrice - Ask >= PipStep * Point) TradeNow = TRUE;
    if (ShortTrade && Bid - LastSellPrice >= PipStep * Point) TradeNow = TRUE;
  }
  else 
  //===================================================================================================================
  // ,     ,    ,  
  //    -   .
  //===================================================================================================================
  {
    ShortTrade = FALSE;
    LongTrade = FALSE;
    TradeNow = TRUE;
    StartEquity = AccountEquity();
  }
   
  //===================================================================================================================
  //   ,       .
  //===================================================================================================================
  if((total > 0) && !(total > MaxTrades)) 
    if(TradeNow)
    {
      //Print("PipStep = ",PipStep);
      iLots = NormalizeDouble(Lots * MathPow(LotExponent, total), lotdecimal);
      if (ShortTrade) 
      {
        ticket = SendMarketOrder(OP_SELL, iLots, 0, 0, MagicNumber, EAName + "-" + NumOfTrades + "-" + PipStep, Error);
      }
      if (LongTrade) 
      {
        ticket = SendMarketOrder(OP_BUY, iLots, 0, 0, MagicNumber, EAName + "-" + NumOfTrades + "-" + PipStep, Error);
      }
      if(ticket > 0)
      {
        TradeNow = FALSE;
        NewOrdersPlaced = TRUE;
        NeedModifyOrder = TRUE;
      }
      else
        return(0);
    }
  //====================================================================================================================
  //   ,      .
  //====================================================================================================================
  if (TradeNow && total < 1)
  {
    Print("  ");
    ticket = 0;
    int tf = mper[Rsi_TF];
    PrevCl = iClose(Symbol(), 0, 2);
    CurrCl = iClose(Symbol(), 0, 1);
    if (PrevCl > CurrCl) 
    {
      Print("  SELL");
      if (iRSI(NULL, tf, RsiPeriod, PRICE_CLOSE, 1) > RsiMin )
      {
       if(Debug) Print(" .");
       ticket = SendMarketOrder(OP_SELL, Lots, 0, 0, MagicNumber, EAName, Error);
       if(ticket > 0)
       if(OrderSelect(ticket,SELECT_BY_TICKET))
       ModifyOrder(OrderOpenPrice() - TakeProfit * Point);
      }
    } 
    if (PrevCl < CurrCl) 
    {
      Print("  BUY");
      if (iRSI(NULL, tf, RsiPeriod, PRICE_CLOSE, 1) < RsiMax ) 
      {
       if(Debug) Print(" .");
       ticket = SendMarketOrder(OP_BUY, Lots, 0, 0, MagicNumber, EAName, Error);
       if(ticket > 0)
       if(OrderSelect(ticket,SELECT_BY_TICKET))
       ModifyOrder(OrderOpenPrice() + TakeProfit * Point);
      }
    }
    if(ticket > 0)
    {
      TradeNow = FALSE;
      NewOrdersPlaced = TRUE;
      NeedModifyOrder = False;
    }
    else
      return(0);
  }
  
  AveragePrice = CalculateAveragePrice();
  //===================================================================================================================
  //         
  //===================================================================================================================
  if (NewOrdersPlaced) 
  {
    if(ShortTrade) 
    {
      PriceTarget = AveragePrice - TakeProfit * Point;
      NeedModifyOrder = TRUE;
    }
    if(LongTrade) 
    {
      PriceTarget = AveragePrice + TakeProfit * Point;
      NeedModifyOrder = TRUE;
    }
  }
   
  if (NewOrdersPlaced)
    if (NeedModifyOrder) 
    {
      Print("    ");
      for (int i1 = 0; i1 < OrdersTotal(); i1++) 
        if(OrderSelect(i1, SELECT_BY_POS, MODE_TRADES))
          if (OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber) 
            ModifyOrder(PriceTarget);
      NewOrdersPlaced = FALSE;
    }
  return (0);
}
//====================================================================================================================
int CountOfOrders()
{
  int count = 0;
  for (int i = 0; i < OrdersTotal(); i++) 
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
      if ((OrderSymbol() == Symbol()) && (OrderMagicNumber() == MagicNumber)) 
        if ((OrderType() == OP_SELL) || (OrderType() == OP_BUY)) 
          count++;
  return(count);
}
//====================================================================================================================
void CloseThisSymbolAll() {
   for (int trade = OrdersTotal() - 1; trade >= 0; trade--) {
      OrderSelect(trade, SELECT_BY_POS, MODE_TRADES);
      if (OrderSymbol() == Symbol()) {
         if (OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber) {
            if (OrderType() == OP_BUY) OrderClose(OrderTicket(), OrderLots(), Bid, Slippage, Blue);
            if (OrderType() == OP_SELL) OrderClose(OrderTicket(), OrderLots(), Ask, Slippage, Red);
         }
         Sleep(1000);
      }
   }
}
//====================================================================================================================
int SendMarketOrder(int Type, double Lots, int TP, int SL, int Magic, string Cmnt, int& Error)
{
  double Price, Take, Stop;
  int Ticket, Slippage, Color, Err; 
  bool Delay = False;
  if(Debug) Print(" SendMarketOrder");
  while(!IsStopped())
  {
    if(!IsConnected())
    {
      //Error = ERR_NO_CONNECTION;
      Print("   !");
      //return(-1);
    }
    if(Debug) Print("   ");
    if(IsTradeContextBusy())
    {
      if(Debug) Print("  !");
      if(Debug) Print(" 5 ...");
      Sleep(5000);
      Delay = True;
      continue;
    }
    if(Debug) Print("  ");
    if(Delay || (LastTickTime != MarketInfo(Symbol(),MODE_TIME))) 
    {
      if(Debug) Print(" ");
      RefreshRates();
      LastTickTime = MarketInfo(Symbol(),MODE_TIME);
      Delay = False;
    }
    else
    {
      if(Debug) Print(" ");
    }
    switch(Type)
    {
      case OP_BUY:
        if(Debug) Print("   BUY-");
        Price = NormalizeDouble( Ask, Digits);
        Take = IIFd(TP == 0, 0, NormalizeDouble( Price + TP * Point, Digits));
        Stop = IIFd(SL == 0, 0, NormalizeDouble( Price - SL * Point, Digits));
        Color = Blue;
        break;
      case OP_SELL:
        if(Debug) Print("   SELL-");
        Price = NormalizeDouble( Bid, Digits);
        Take = IIFd(TP == 0, 0, NormalizeDouble( Price - TP * Point, Digits));
        Stop = IIFd(SL == 0, 0, NormalizeDouble( Price + SL * Point, Digits));
        Color = Red;
        break;
      default:
        if(Debug) Print("    .");
        return(-1);
    }
    Slippage = 2*(MarketInfo(Symbol(), MODE_SPREAD));
    if(Debug) Print("Slippage = ",Slippage);
    if(IsTradeAllowed())
    {
      if(Debug) Print(" ,  ...");
      Ticket = OrderSend(Symbol(), Type, Lots, Price, Slippage, Stop, Take, Cmnt, Magic, 0, Color);
      if(Ticket < 0)
      {
        Err = GetLastError();
        if (Err == 4   || /* SERVER_BUSY */
            Err == 129 || /* INVALID_PRICE */ 
            Err == 135 || /* PRICE_CHANGED */ 
            Err == 137 || /* BROKER_BUSY */ 
            Err == 138 || /* REQUOTE */ 
            Err == 146 || /* TRADE_CONTEXT_BUSY */
            Err == 136 )  /* OFF_QUOTES */
        {
          if(Debug) Print("(OrderSend - ", Err, "): ", ErrorDescription(Err));
          if(Debug) Print(" 5 ...");
          Sleep(5000);
          Delay = True;
          continue;
        }
        else
        {
          if(Debug) Print(" (OrderSend - ", Err, "): ", ErrorDescription(Err));
          Error = Err;
          break;
        }
      }
      break;
    }
    else
    {
      if(Debug) Print("  !     .");
      
      break;
    }
  }
  if(Ticket > 0)
    if(Debug) Print("  .  = ",Ticket);
  else
    if(Debug) Print("!   . (ErrorCode = ", Error, ": ", ErrorDescription(Error), ")");
  return(Ticket);
}
//=======================================================================================================
double IIFd(bool condition, double ifTrue, double ifFalse) 
{
  if (condition) return(ifTrue); else return(ifFalse);
}
//=======================================================================================================
double CalculateProfit() 
{
  double Profit = 0;
  for (int i = 0; i < OrdersTotal(); i++) 
    if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
      if ((OrderSymbol() == Symbol()) && (OrderMagicNumber() == MagicNumber))
        if ((OrderType() == OP_BUY) || (OrderType() == OP_SELL)) 
          Profit += OrderProfit();
  return (Profit);
}
//=======================================================================================================
double AccountEquityHigh() 
{
   if (CountOfOrders() == 0) AccountEquityHighAmt = AccountEquity();
   if (AccountEquityHighAmt < PrevEquity) AccountEquityHighAmt = PrevEquity;
   else AccountEquityHighAmt = AccountEquity();
   PrevEquity = AccountEquity();
   return (AccountEquityHighAmt);
}
//=======================================================================================================
double FindLastBuyPrice() {
   double oldorderopenprice;
   int oldticketnumber;
   double unused = 0;
   int ticketnumber = 0;
   for (int cnt = OrdersTotal() - 1; cnt >= 0; cnt--) {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if (OrderSymbol() != Symbol() || OrderMagicNumber() != MagicNumber) continue;
      if (OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber && OrderType() == OP_BUY) {
         oldticketnumber = OrderTicket();
         if (oldticketnumber > ticketnumber) {
            oldorderopenprice = OrderOpenPrice();
            unused = oldorderopenprice;
            ticketnumber = oldticketnumber;
         }
      }
   }
   return (oldorderopenprice);
}
double FindLastSellPrice() {
   double oldorderopenprice;
   int oldticketnumber;
   double unused = 0;
   int ticketnumber = 0;
   for (int cnt = OrdersTotal() - 1; cnt >= 0; cnt--) {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if (OrderSymbol() != Symbol() || OrderMagicNumber() != MagicNumber) continue;
      if (OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber && OrderType() == OP_SELL) {
         oldticketnumber = OrderTicket();
         if (oldticketnumber > ticketnumber) {
            oldorderopenprice = OrderOpenPrice();
            unused = oldorderopenprice;
            ticketnumber = oldticketnumber;
         }
      }
   }
   return (oldorderopenprice);
}
//========================================================================================================
double CalculateAveragePrice()
{
  double AveragePrice = 0;
  double Count = 0;
  for (int i = 0; i < OrdersTotal(); i++)
    if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
      if (OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber)
        if (OrderType() == OP_BUY || OrderType() == OP_SELL) 
        {
           AveragePrice += OrderOpenPrice() * OrderLots();
           Count += OrderLots();
        }
  if(AveragePrice > 0 && Count > 0)
    return( NormalizeDouble(AveragePrice / Count, Digits));
  else
    return(0);
}

bool ModifyOrder( double takeprofit)
{
  while(!IsStopped())
  {
    Print(" ModifyOrder");
    if(IsTradeContextBusy())
    {
      Print("  !");
      Sleep(3000);
      continue;
    }
    Print("  ");
    if(!IsTradeAllowed())
    {
      Print("  !");
      //Sleep(3000);
      //continue;
      return(False);
    }
    Print(" ,   #",OrderTicket());
    if(!OrderModify(OrderTicket(), OrderOpenPrice(), 0, NormalizeDouble(takeprofit,Digits), 0, Yellow))
    {
      Print("   ");
      int Err = GetLastError();
      Print("(",Err,"): ",ErrorDescription(Err));
      return(False);
      //break;
      //Sleep(1000);
      //continue;
    }
    else
    {
      Print("   ");
      break;
    }
  }
  return(True);
}